import isFunction from '@roots/bud-support/isFunction';
/**
 * Calls a given value if it is a function. The function will be bound to
 * Budbefore it is called.
 *
 * If it is not a function, returns the value without doing anything to it.
 *
 * @typeParam I - Type of the value expected to be returned
 */
const maybeCall = function (value, ...params) {
    if (!params.length)
        params.push(this);
    return isFunction(value)
        ? typeof value.bind !== `undefined`
            ? value.bind(this)(...params)
            : value(...params)
        : value;
};
export { maybeCall };
